diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index 6a63af17b..4437d04bb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -1,169 +1,209 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.Font;
-import net.minecraft.client.render.ItemRenderer;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
+import org.useless.dragonfly.DisplayPos;
 
 import java.awt.*;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.Objects;
 import java.util.Random;
 
 import static org.lwjgl.opengl.GL11.GL_BLEND;
-import static org.lwjgl.opengl.GL11.GL_CULL_FACE;
 import static org.lwjgl.opengl.GL11.GL_DEPTH_TEST;
 import static org.lwjgl.opengl.GL11.GL_LIGHTING;
-import static org.lwjgl.opengl.GL11.GL_ONE_MINUS_SRC_ALPHA;
-import static org.lwjgl.opengl.GL11.GL_SRC_ALPHA;
 import static org.lwjgl.opengl.GL11.GL_TEXTURE_2D;
 import static org.lwjgl.opengl.GL11.glBlendFunc;
 import static org.lwjgl.opengl.GL11.glDisable;
 import static org.lwjgl.opengl.GL11.glEnable;
-import static org.lwjgl.opengl.GL11.glPopMatrix;
-import static org.lwjgl.opengl.GL11.glPushMatrix;
-import static org.lwjgl.opengl.GL11.glRotated;
-import static org.lwjgl.opengl.GL11.glScaled;
-import static org.lwjgl.opengl.GL11.glTranslated;
 
 public class ItemModelStandard extends ItemModel{
-    final Minecraft mc = Minecraft.getMinecraft();
+    protected static final Random random = new Random();
+
     public static final IconCoordinate ITEM_TEXTURE_MISSING = TextureRegistry.getTexture("minecraft:item/texture_missing");
     public static final IconCoordinate ITEM_TEXTURE_UNASSIGNED = TextureRegistry.getTexture("minecraft:item/texture_unassigned");
-    protected boolean useColor = true;
     public IconCoordinate icon = ITEM_TEXTURE_UNASSIGNED;
-    protected boolean bFull3D = false;
-    protected boolean rotateWhenRendering = false;
-    protected boolean pointInfrontOfPlayer = false;
+    protected @NotNull Map<@NotNull String, @NotNull DisplayPos> displayPosMap = new HashMap<>();
+
+    public static final DisplayPos DEFAULT_ITEM_GROUND = new DisplayPos(0, 2/16f, 0, 0, 0, 0, 0.5f, 0.5f, 0.5f);
+    public static final DisplayPos DEFAULT_ITEM_HEAD = new DisplayPos(0, 14/16f, 0, 0, 0, 0, 1, 1, 1); // This is different from modern mc's default
+    public static final DisplayPos DEFAULT_ITEM_THIRD_PERSON_RIGHT_HAND = new DisplayPos(0, 3/16f, 1/16f, 0, 0, 0, 0.55f, 0.55f, 0.55f);
+    public static final DisplayPos DEFAULT_ITEM_THIRD_PERSON_LEFT_HAND = new DisplayPos(-0, 3/16f, 1/16f, -0, 0, 0, 0.55f, 0.55f, 0.55f);
+    public static final DisplayPos DEFAULT_ITEM_FIRST_PERSON_RIGHT_HAND = new DisplayPos(1.13f/16f, 3.2f/16f, 1.13f/16f, 0, -90, 25, 0.68f, 0.68f, 0.68f);
+    public static final DisplayPos DEFAULT_ITEM_FIRST_PERSON_LEFT_HAND = new DisplayPos(-1.13f/16f, 3.2f/16f, 1.13f/16f, -0, -90, 25, 0.68f, 0.68f, 0.68f);
+    public static final DisplayPos DEFAULT_ITEM_FIXED = new DisplayPos(0, 0, 0, 0, 180, 0, 1, 1, 1);
+
     protected boolean itemfullBright = false;
 
     public ItemModelStandard(Item item, String namespace) {
         super(item);
+        displayPosMap.put(DisplayPos.GROUND, DEFAULT_ITEM_GROUND);
+        displayPosMap.put(DisplayPos.HEAD, DEFAULT_ITEM_HEAD);
+        displayPosMap.put(DisplayPos.THIRD_PERSON_RIGHT_HAND, DEFAULT_ITEM_THIRD_PERSON_RIGHT_HAND);
+        displayPosMap.put(DisplayPos.THIRD_PERSON_LEFT_HAND, DEFAULT_ITEM_THIRD_PERSON_LEFT_HAND); // TODO make automatic since its just the axis flipped
+        displayPosMap.put(DisplayPos.FIRST_PERSON_RIGHT_HAND, DEFAULT_ITEM_FIRST_PERSON_RIGHT_HAND);
+        displayPosMap.put(DisplayPos.FIRST_PERSON_LEFT_HAND, DEFAULT_ITEM_FIRST_PERSON_LEFT_HAND); // TODO make automatic since its just the axis flipped
+        displayPosMap.put(DisplayPos.FIXED, DEFAULT_ITEM_FIXED);
         if (namespace != null){
             icon = TextureRegistry.getTexture(namespace + ":item/" + item.getKey().substring("item.".length()).replace(".", "_"));
         }
     }
 
     @Override
-    public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, Player player, ItemStack stack, float partialTick) {
-        float brightness = 1.0f;
-        if(mc.fullbright || itemfullBright || LightmapHelper.isLightmapEnabled()) {
-        	if(LightmapHelper.isLightmapEnabled()) {
-            	int lightmapCoord = player.getLightmapCoord(partialTick);
-            	if(itemfullBright) {
-            		lightmapCoord = LightmapHelper.setBlocklightValue(lightmapCoord, 15);
-            	}
-            	LightmapHelper.setLightmapCoord(lightmapCoord);	
-        	}
-        }else {
-        	brightness = player.getBrightness(1.0f);
+    public void render(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, float brightness, float alpha, float partialTick, boolean mirrorX) {
+        random.setSeed(187L);
+        DisplayPos displayPos = getDisplayPos(displayPosId);
+        GL11.glTranslatef(displayPos.tx, displayPos.ty, displayPos.tz);
+        GL11.glRotatef(displayPos.rx, 1, 0, 0);
+        GL11.glRotatef(displayPos.ry, 0, 1, 0);
+        GL11.glRotatef(displayPos.rz, 0, 0, 1);
+        GL11.glScalef(displayPos.sx, displayPos.sy, displayPos.sz);
+        int color = getColor(itemStack);
+        float r = net.minecraft.core.util.helper.Color.redFromInt(color)/255f;
+        float g = net.minecraft.core.util.helper.Color.greenFromInt(color)/255f;
+        float b = net.minecraft.core.util.helper.Color.blueFromInt(color)/255f;
+        GL11.glColor4f(brightness * r, brightness * g, brightness * b, alpha);
+        if (items3d) {
+            for (int i = 0; i < clusterSize; i++) {
+                float offX = 0;
+                float offY = 0;
+                float offZ = 0.1f * i;
+                GL11.glTranslatef(offX, offY, offZ);
+                renderSingle(tessellator, holder, itemStack, true, brightness, alpha, partialTick, mirrorX);
+                GL11.glTranslatef(-offX, -offY, -offZ);
+            }
+        } else {
+            for (int i = 0; i < clusterSize; i++) {
+                float rOffX = 0;
+                float rOffY = 0;
+                float rOffZ = 0;
+                if (i > 0) {
+                    rOffX = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / displayPos.sx;
+                    rOffY = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / displayPos.sy;
+                    rOffZ = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / displayPos.sz;
+                }
+                GL11.glTranslatef(rOffX, rOffY, rOffZ);
+                renderSingle(tessellator, holder, itemStack, false, brightness, alpha, partialTick, mirrorX);
+                GL11.glTranslatef(-rOffX, -rOffY, -rOffZ);
+            }
         }
+    }
 
-        final float distanceScale = 0.8F; // Relates to how close the held item renders from the camera
-        final float swingProgress = player.getSwingProgress(partialTick);
-        final float animationProgress2 = MathHelper.sin(swingProgress * MathHelper.PI);
-        final float animationProgress = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
+    protected void renderSingle(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, boolean items3d, float brightness, float alpha, float partialTick, boolean mirrorX) {
+        renderCoordinate(tessellator, getIcon(holder, itemStack), items3d, mirrorX);
+    }
 
-        GL11.glTranslatef(-animationProgress * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -animationProgress2 * 0.2F); // Makes swing travel in an arc
-        GL11.glTranslatef(0.7F * distanceScale, -0.65F * distanceScale - (1.0F - renderer.getEquippedProgress(partialTick)) * 0.6F, -0.9F * distanceScale); // Positions hand in correct place on right side of screen
-        GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F); // 45 degrees tilt, makes it face more towards the camera
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+    protected void renderCoordinate(@NotNull Tessellator tessellator, @NotNull IconCoordinate coordinate, boolean items3d, boolean mirrorX) {
+        final double cUMin = mirrorX ? coordinate.getIconUMax() : coordinate.getIconUMin();
+        final double cUMax = mirrorX ? coordinate.getIconUMin() : coordinate.getIconUMax();
+        final double cVMin = coordinate.getIconVMin();
+        final double cVMax = coordinate.getIconVMax();
+
+        coordinate.parentAtlas.bind();
+        if (items3d) {
+            final float halfThickness = 0.5f/16f;
+            final int pxH = coordinate.height;
+            final int pxW = coordinate.width;
+
+            tessellator.startDrawingQuads();
+            // front
+            tessellator.setNormal(0, 0, -1);
+            tessellator.addVertexWithUV(-0.5,  0.5, -halfThickness, cUMin, cVMin);
+            tessellator.addVertexWithUV( 0.5,  0.5, -halfThickness, cUMax, cVMin);
+            tessellator.addVertexWithUV( 0.5, -0.5, -halfThickness, cUMax, cVMax);
+            tessellator.addVertexWithUV(-0.5, -0.5, -halfThickness, cUMin, cVMax);
+
+            // top bottom
+            for (int h = 0; h < pxH; h++) {
+                double y1 = (double) h /pxH;
+                double y2 = (double) (h + 1) /pxH;
+                double vMin = coordinate.getSubIconV(y1);
+                double vMax = coordinate.getSubIconV(y2);
+
+                // top
+                tessellator.setNormal(0, 1, 0);
+                tessellator.addVertexWithUV(-0.5, 0.5 - y1, -halfThickness, cUMin, vMin);
+                tessellator.addVertexWithUV(-0.5, 0.5 - y1,  halfThickness, cUMin, vMax);
+                tessellator.addVertexWithUV( 0.5, 0.5 - y1,  halfThickness, cUMax, vMax);
+                tessellator.addVertexWithUV( 0.5, 0.5 - y1, -halfThickness, cUMax, vMin);
+
+                // bottom
+                tessellator.setNormal(0, -1, 0);
+                tessellator.addVertexWithUV(-0.5, 0.5 - y2, -halfThickness, cUMin, vMin);
+                tessellator.addVertexWithUV( 0.5, 0.5 - y2, -halfThickness, cUMax, vMin);
+                tessellator.addVertexWithUV( 0.5, 0.5 - y2,  halfThickness, cUMax, vMax);
+                tessellator.addVertexWithUV(-0.5, 0.5 - y2,  halfThickness, cUMin, vMax);
+            }
 
-        float animationProgress3 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
-        GL11.glRotatef(-animationProgress3 * 20F, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(-animationProgress * 20F, 0.0F, 0.0F, 1.0F);
-        GL11.glRotatef(-animationProgress * 80F, 1.0F, 0.0F, 0.0F);
+            // left right
+            for (int w = 0; w < pxW; w++) {
+                double x1 = (double) w / pxW;
+                double x2 = (double) (w + 1) / pxW;
 
-        final float scale = 0.4F;
-        GL11.glScalef(scale, scale, scale);
 
-        heldTransformFirstPerson(renderer, player, stack);
+                double uMin = coordinate.getSubIconU(mirrorX ? 1 - x1 : x1);
+                double uMax = coordinate.getSubIconU(mirrorX ? 1 - x2 : x2);
 
-        renderItem(tessellator, renderer, stack, player, brightness, true);
-    }
-
-    @Override
-    public void renderItem(Tessellator tessellator, ItemRenderer renderer, ItemStack itemstack, @Nullable Entity entity, float brightness, boolean handheldTransform) {
-        if (itemfullBright || LightmapHelper.isLightmapEnabled()) {
-        	brightness = 1.0f;
-        }
-        if(handheldTransform) {
-            GL11.glTranslatef(-0.0F, -0.3F, 0.0F);
-            final float handheldScale = 1.5F;
-            GL11.glScalef(handheldScale, handheldScale, handheldScale);
-            GL11.glRotatef(50F, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(335F, 0.0F, 0.0F, 1.0F);
-            GL11.glTranslatef(-0.9375F, -0.0625F, 0.0F);
-        }
+                // right
+                tessellator.setNormal(-1, 0, 0);
+                tessellator.addVertexWithUV(x1 - 0.5,  0.5, -halfThickness, uMin, cVMin);
+                tessellator.addVertexWithUV(x1 - 0.5, -0.5, -halfThickness, uMax, cVMax);
+                tessellator.addVertexWithUV(x1 - 0.5, -0.5,  halfThickness, uMax, cVMax);
+                tessellator.addVertexWithUV(x1 - 0.5,  0.5,  halfThickness, uMin, cVMin);
 
-        renderItemInWorld(tessellator, entity, itemstack, brightness, 1f, false);
+                // left
+                tessellator.setNormal(1, 0, 0);
+                tessellator.addVertexWithUV(x2 - 0.5,  0.5, -halfThickness, uMin, cVMin);
+                tessellator.addVertexWithUV(x2 - 0.5,  0.5,  halfThickness, uMin, cVMin);
+                tessellator.addVertexWithUV(x2 - 0.5, -0.5,  halfThickness, uMax, cVMax);
+                tessellator.addVertexWithUV(x2 - 0.5, -0.5, -halfThickness, uMax, cVMax);
+            }
 
+            // back
+            tessellator.setNormal(0, 0, 1);
+            tessellator.addVertexWithUV(-0.5,  0.5, halfThickness, cUMin, cVMin);
+            tessellator.addVertexWithUV(-0.5, -0.5, halfThickness, cUMin, cVMax);
+            tessellator.addVertexWithUV( 0.5, -0.5, halfThickness, cUMax, cVMax);
+            tessellator.addVertexWithUV( 0.5,  0.5, halfThickness, cUMax, cVMin);
+            tessellator.draw();
+        } else {
+            tessellator.startDrawingQuads();
+            tessellator.addVertexWithUV(-0.5,  0.5, 0, cUMin, cVMin);
+            tessellator.addVertexWithUV(-0.5, -0.5, 0, cUMin, cVMax);
+            tessellator.addVertexWithUV( 0.5, -0.5, 0, cUMax, cVMax);
+            tessellator.addVertexWithUV( 0.5,  0.5, 0, cUMax, cVMin);
+
+            tessellator.addVertexWithUV(-0.5,  0.5, 0, cUMin, cVMin);
+            tessellator.addVertexWithUV( 0.5,  0.5, 0, cUMax, cVMin);
+            tessellator.addVertexWithUV( 0.5, -0.5, 0, cUMax, cVMax);
+            tessellator.addVertexWithUV(-0.5, -0.5, 0, cUMin, cVMax);
+            tessellator.draw();
+        }
     }
 
-    @Override
-    public void renderItemThirdPerson(Tessellator tessellator, ItemRenderer renderer, Entity entity, ItemStack itemstack, boolean handheldTransform) {
-        float brightness = 1.0f;
-        if(mc.fullbright || itemfullBright || LightmapHelper.isLightmapEnabled()) {
-        	if(LightmapHelper.isLightmapEnabled()) {
-            	int lightmapCoord = entity.getLightmapCoord(1.0f);
-            	if(itemfullBright) {
-            		lightmapCoord = LightmapHelper.getLightmapCoord(15, 15);
-            	}
-            	LightmapHelper.setLightmapCoord(lightmapCoord);	
-        	}
-        }else {
-        	brightness = entity.getBrightness(1.0f);
-        }
-        
-        GL11.glTranslatef(-0.0625F, 0.4375F, 0.0625F);
-        heldTransformThirdPerson(renderer, entity, itemstack);
-        renderItem(tessellator, renderer, itemstack, entity, brightness, handheldTransform);
+    public @NotNull DisplayPos getDisplayPos(@NotNull String id) {
+        return displayPosMap.getOrDefault(id, DisplayPos.DEFAULT_DISPLAY_POS);
     }
 
-    @Override
-    public void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemStack, int x, int y, float brightness, float alpha) {
-        if (itemStack == null) return;
-        Minecraft mc = Minecraft.getMinecraft();
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glDisable(GL_LIGHTING);
-        GL11.glEnable(GL_BLEND);
-        GL11.glEnable(GL_CULL_FACE);
-        IconCoordinate textureIndex = getIcon(mc.thePlayer, itemStack);
-        textureIndex.parentAtlas.bind();
-        if (useColor) {
-            final int color = getColor(itemStack);
-            final float r = (color >> 16 & 0xff) / 255F;
-            final float g = (color >> 8 & 0xff) / 255F;
-            final float b = (color & 0xff) / 255F;
-            GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-        } else {
-            GL11.glColor4f(brightness, brightness, brightness, alpha);
-        }
-        renderTexturedQuad(tessellator, x, y, textureIndex);
-        GL11.glEnable(GL_LIGHTING);
-        GL11.glDisable(GL_CULL_FACE);
-        GL11.glDisable(GL11.GL_BLEND);
+    public @NotNull ItemModelStandard setDisplayPos(@NotNull String id, @NotNull DisplayPos displayPos) {
+        this.displayPosMap.put(id, Objects.requireNonNull(displayPos, "Display pos cannot be null!"));
+        return this;
     }
 
     @Override
-    public void renderItemOverlayIntoGUI(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemstack, int x, int y, String override, float alpha) {
+    public void renderItemOverlayIntoGUI(@NotNull Tessellator tessellator, @NotNull Font font, @NotNull TextureManager textureManager, @NotNull ItemStack itemstack, int x, int y, @Nullable String override, float alpha) {
         glEnable(GL_BLEND);
         glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        if (itemstack == null) {
-            return;
-        }
         final int a = (int) (alpha * 255.0f);
         if (itemstack.stackSize != 1 || override != null) {
             String s = override != null ? override : "" + itemstack.stackSize;
@@ -192,238 +232,6 @@ public class ItemModelStandard extends ItemModel{
         glDisable(GL_BLEND);
     }
 
-    @Override
-    public void renderAsItemEntity(Tessellator tessellator, @Nullable Entity entity, Random random, ItemStack itemstack, int renderCount, float yaw, float brightness, float partialTick) {
-        final Minecraft mc = Minecraft.getMinecraft();
-        if (mc.fullbright || itemfullBright) brightness = 1.0f;
-
-        EntityRenderDispatcher renderDispatcher = EntityRenderDispatcher.instance;
-        GL11.glScalef(0.5F, 0.5F, 0.5F);
-        final IconCoordinate tex = getIcon(entity, itemstack);
-        tex.parentAtlas.bind();
-        if (useColor) {
-            final int color = getColor(itemstack);
-            final float r = (color >> 16 & 0xff) / 255F;
-            final float g = (color >> 8 & 0xff) / 255F;
-            final float b = (color & 0xff) / 255F;
-            GL11.glColor4f(r * brightness, g * brightness, b * brightness, 1.0F);
-        }  else {
-            GL11.glColor4f(brightness, brightness, brightness, 1.0F);
-        }
-        if(LightmapHelper.isLightmapEnabled() && itemfullBright && entity != null) {
-        	int lmc = entity.getLightmapCoord(1.0f);
-        	lmc = LightmapHelper.setBlocklightValue(lmc, 15);
-        	LightmapHelper.setLightmapCoord(lmc);
-        }
-        if(mc.gameSettings.items3D.value) {
-            glPushMatrix();
-
-            glScaled(1.0, 1.0, 1.0);
-            glRotated(yaw, 0, 1, 0);
-            glTranslated(-0.5, 0.0, -0.05 * (renderCount - 1));
-
-            for(int i=0; i < renderCount; i++) {
-                glPushMatrix();
-
-                glTranslated(0.0, 0.0, 0.1 * i);
-                renderItem(tessellator, renderDispatcher.itemRenderer, itemstack, entity, brightness, false);
-                glPopMatrix();
-            }
-
-            glPopMatrix();
-        } else {
-            for (int i = 0; i < renderCount; i++) {
-                glPushMatrix();
-                if (i > 0) {
-                    final float rOffX = (random.nextFloat() * 2.0F - 1.0F) * 0.3F;
-                    final float rOffY = (random.nextFloat() * 2.0F - 1.0F) * 0.3F;
-                    final float rOffZ = (random.nextFloat() * 2.0F - 1.0F) * 0.3F;
-                    GL11.glTranslatef(rOffX, rOffY, rOffZ);
-                }
-                GL11.glRotatef(180F - renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
-                renderFlat(tessellator, tex);
-                GL11.glPopMatrix();
-            }
-        }
-    }
-
-    @Override
-    public void renderItemInWorld(Tessellator tessellator, Entity entity, ItemStack itemStack, float brightness, float alpha, boolean worldTransform) {
-        GL11.glEnable(GL_BLEND);
-        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-        if (useColor) {
-            final int color = getColor(itemStack);
-            final float r = (color >> 16 & 0xff) / 255F;
-            final float g = (color >> 8 & 0xff) / 255F;
-            final float b = (color & 0xff) / 255F;
-            GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-        }  else {
-            GL11.glColor4f(brightness, brightness, brightness, alpha);
-        }
-
-        IconCoordinate tex = getIcon(entity, itemStack);
-        tex.parentAtlas.bind();
-        int tileWidth = tex.width;
-
-        float uMin = (float) tex.getIconUMin();
-        float uMax = (float) tex.getIconUMax();
-        float vMin = (float) tex.getIconVMin();
-        float vMax = (float) tex.getIconVMax();
-        float uDiff = uMin - uMax;
-        float vDiff = vMin - vMax;
-        final float width = 1.0F;
-
-        final float foon = (0.5f / tex.parentAtlas.getHeight());
-        final float goon = 0.0625f * (16.0f / tileWidth);
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        final float thickness = 0.0625f;
-        final float pixelWidth = 1f/tileWidth;
-
-        if (worldTransform){
-            GL11.glTranslatef(-0.5f, -0.5f, thickness/2);
-        }
-
-        // Back Face
-        tessellator.startDrawingQuads();
-        tessellator.setNormal(0.0F, 0.0F, 1.0F);
-        tessellator.addVertexWithUV(0.0D, 0.0D, 0.0D, uMax, vMax);
-        tessellator.addVertexWithUV(width,0.0D, 0.0D, uMin, vMax);
-        tessellator.addVertexWithUV(width,1.0D, 0.0D, uMin, vMin);
-        tessellator.addVertexWithUV(0.0D, 1.0D, 0.0D, uMax, vMin);
-        tessellator.draw();
-
-        // Front Face
-        tessellator.startDrawingQuads();
-        tessellator.setNormal(0.0F, 0.0F, -1F);
-        tessellator.addVertexWithUV(0.0D, 1.0D, -thickness, uMax, vMin);
-        tessellator.addVertexWithUV(width,1.0D, -thickness, uMin, vMin);
-        tessellator.addVertexWithUV(width,0.0D, -thickness, uMin, vMax);
-        tessellator.addVertexWithUV(0.0D, 0.0D, -thickness, uMax, vMax);
-        tessellator.draw();
-
-        // Right Sides
-        tessellator.startDrawingQuads();
-        tessellator.setNormal(-1F, 0.0F, 0.0F);
-        for(int i = 0; i < tileWidth; i++)
-        {
-            float texProgress = i * pixelWidth;
-            float u = (uMax + uDiff * texProgress) - foon;
-            float x = width * texProgress;
-            tessellator.addVertexWithUV(x, 0.0D,    -thickness, u, vMax);
-            tessellator.addVertexWithUV(x, 0.0D,    0.0D,       u, vMax);
-            tessellator.addVertexWithUV(x, 1.0D,    0.0D,       u, vMin);
-            tessellator.addVertexWithUV(x, 1.0D,    -thickness, u, vMin);
-        }
-        tessellator.draw();
-
-        // Left Sides
-        tessellator.startDrawingQuads();
-        tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        for(int i = 0; i < tileWidth; i++)
-        {
-            float texProgress = i * pixelWidth;
-            float u = (uMax + uDiff * texProgress) - foon;
-            float x = width * texProgress + goon;
-            tessellator.addVertexWithUV(x, 1.0D,    -thickness, u, vMin);
-            tessellator.addVertexWithUV(x, 1.0D,    0.0D,       u, vMin);
-            tessellator.addVertexWithUV(x, 0.0D,    0.0D,       u, vMax);
-            tessellator.addVertexWithUV(x, 0.0D,    -thickness, u, vMax);
-        }
-        tessellator.draw();
-
-        // Top Sides
-        tessellator.startDrawingQuads();
-        tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        for(int i = 0; i < tileWidth; i++)
-        {
-            float texProgress = i * pixelWidth;
-            float v = (vMax + vDiff * texProgress) - foon;
-            float y = width * texProgress + goon;
-            tessellator.addVertexWithUV(0.0D,   y,  0.0D,       uMax, v);
-            tessellator.addVertexWithUV(width,  y,  0.0D,       uMin, v);
-            tessellator.addVertexWithUV(width,  y,  -thickness, uMin, v);
-            tessellator.addVertexWithUV(0.0D,   y,  -thickness, uMax, v);
-        }
-        tessellator.draw();
-
-        // Bottom Sides
-        tessellator.startDrawingQuads();
-        tessellator.setNormal(0.0F, -1F, 0.0F);
-        for(int i = 0; i < tileWidth; i++)
-        {
-            float texProgress = i * pixelWidth;
-            float v = (vMax + vDiff * texProgress) - foon;
-            float y = width * texProgress;
-            tessellator.addVertexWithUV(width,  y, 0.0D,        uMin, v);
-            tessellator.addVertexWithUV(0.0D,   y, 0.0D,        uMax, v);
-            tessellator.addVertexWithUV(0.0D,   y, -thickness,  uMax, v);
-            tessellator.addVertexWithUV(width,  y, -thickness,  uMin, v);
-        }
-        tessellator.draw();
-
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
-        GL11.glDisable(GL_BLEND);
-    }
-
-    public void renderFlat(Tessellator tessellator, IconCoordinate index){
-        final float xOff = 0.5F;
-        final float yOff = 0.25F;
-        final float z = 0;
-        tessellator.startDrawingQuads();
-        tessellator.setNormal(0.0F, 1.0F, 0.0F);
-        tessellator.addVertexWithUV(0.0F - xOff, 0.0F - yOff, z, index.getIconUMin(), index.getIconVMax());
-        tessellator.addVertexWithUV(1.0F - xOff, 0.0F - yOff, z, index.getIconUMax(), index.getIconVMax());
-        tessellator.addVertexWithUV(1.0F - xOff, 1.0F - yOff, z, index.getIconUMax(), index.getIconVMin());
-        tessellator.addVertexWithUV(0.0F - xOff, 1.0F - yOff, z, index.getIconUMin(), index.getIconVMin());
-        tessellator.draw();
-    }
-
-    public void heldTransformThirdPerson(ItemRenderer renderer, Entity entity, ItemStack itemStack) {
-        if(bFull3D) {
-            final float scale = 0.625F;
-            if(rotateWhenRendering) {
-                GL11.glRotatef(180F, 0.0F, 0.0F, 1.0F);
-                GL11.glTranslatef(0.0F, -0.125F, 0.0F);
-            }
-            if(pointInfrontOfPlayer) {
-                GL11.glRotatef(-20F, 0.0F, 1.0F, 0.0F);
-                GL11.glTranslatef(0.0F, -0.125F, 0.0F);
-            }
-            GL11.glTranslatef(0.0F, 0.1875F, 0.0F);
-            GL11.glScalef(scale, -scale, scale);
-            GL11.glRotatef(-100F, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
-        } else {
-            final float scale = 0.375F;
-            GL11.glTranslatef(0.25F, 0.1875F, -0.1875F);
-            GL11.glScalef(scale, scale, scale);
-            GL11.glRotatef(60F, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(-90F, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(20F, 0.0F, 0.0F, 1.0F);
-        }
-    }
-    public void heldTransformFirstPerson(ItemRenderer renderer, Entity entity, ItemStack itemStack) {
-        if(rotateWhenRendering)
-        {
-            GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
-        }
-        if(pointInfrontOfPlayer)
-        {
-            GL11.glRotatef(-20F, 0.0F, 1.0F, 0.0F);
-        }
-    }
-    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
-        return icon;
-    }
-    public int getColor(ItemStack stack)
-    {
-        return getColorFromMeta(stack.getMetadata());
-    }
-    public int getColorFromMeta(int meta)
-    {
-        return 0xffffff;
-    }
-
     protected void renderColoredQuad(Tessellator tessellator, int x, int y, int width, int height, int colorRGB, int alpha) {
         final float z = 0.0F;
         tessellator.startDrawingQuads();
@@ -435,50 +243,18 @@ public class ItemModelStandard extends ItemModel{
         tessellator.draw();
     }
 
-    protected void renderTexturedQuad(Tessellator tessellator, int x, int y, IconCoordinate icon) {
-        renderTexturedQuad(tessellator, x, y, icon, false, false);
-    }
-
-    protected void renderTexturedQuad(Tessellator tessellator, int x, int y, IconCoordinate icon, boolean flipX, boolean flipY) {
-        final float z = 0.0F;
-        double uMin = icon.getIconUMin();
-        double uMax = icon.getIconUMax();
-        double vMin = icon.getIconVMin();
-        double vMax = icon.getIconVMax();
-        if (flipX){
-            double _uMin = uMin;
-            uMin = uMax;
-            uMax = _uMin;
-        }
-        if (flipY){
-            double _vMin = vMin;
-            vMin = vMax;
-            vMax = _vMin;
-        }
-        tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x,      y + 16, z, uMin, vMax);
-        tessellator.addVertexWithUV(x + 16, y + 16, z, uMax, vMax);
-        tessellator.addVertexWithUV(x + 16, y,      z, uMax, vMin);
-        tessellator.addVertexWithUV(x,      y,      z, uMin, vMin);
-        tessellator.draw();
-
-    }
-
-    public ItemModelStandard setFull3D()
-    {
-        bFull3D = true;
-        return this;
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
+        return icon;
     }
-    public ItemModelStandard setRotateWhenRendering()
+    public int getColor(ItemStack stack)
     {
-        rotateWhenRendering = true;
-        return this;
+        return getColorFromMeta(stack.getMetadata());
     }
-    public ItemModelStandard setPointInfrontOfPlayer()
+    public int getColorFromMeta(int meta)
     {
-        pointInfrontOfPlayer = true;
-        return this;
+        return 0xffffff;
     }
+
     public ItemModelStandard setFullBright()
     {
         itemfullBright = true;
